#ifndef MELANGEUR_H
#define MELANGEUR_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NAMELEN 64       /* max length of i.e. filenames and sequence names */
#define SEEDFILENAME "seed"  /* name of seed file */
#define MAX_CHAR_PER_LINE    1650   /* Maximum number of characters per line */
#define LMAX                 1000    /* Maximum number of lines */
#define MAXSEQLEN            100000  /* Maximum number of nodes */
#define WDIR "./tmp"     /* directory to write in */

#define randomint(N) ((int)((N)*unif01())+1)  /* random integer 1..N */

#ifdef __cplusplus
extern "C" {
#endif

/* melangeur.c */
void generateseq(int seqlen, char **seq);
void monoshuffle(int seqlen, char **seq);
int openLabelFile(char filename[],char **seq);
int writeLabelFile(char filename[],char **seq, int seqlen);
void generateseqInt(int seqlen, int *seq);
  void generateseqInt2(int seqlen, int *seq, char filename[]);
void monoshuffleInt(int seqlen, int *seq);
int writeLabelFileInt(char filename[],int *seq, int seqlen);

/* main.c */
int parse(int argc, char** argv);
void printHelp();

/* random.c */
double unif01(void);
unsigned int readseed(char filename[]);
int writeseed(char filename[]);

#ifdef __cplusplus
}
#endif

#endif
