#!/usr/bin/perl

# TODO :Parser les genes et les proteines

use strict; use warnings;

my($fileIn) = $ARGV[0];

open(F, "<$fileIn") or die "Error reading \"$fileIn\"";

my %tabCpds = ();

my $line = <F>;


while($line) {
	
	# Creation du tableau associatif idCpd <-> NomCpd
	if ($line =~ "<listOfSpecies>") {
		while(($line = <F>) && (!($line =~ "</listOfSpecies>"))) {
			chomp($line);
			my ($idSpecie) = ($line =~ /id=\"([^\"]*)\"/);
			my ($nameSpecie) = ($line =~ /name=\"([^\"]*)\"/);
			
			$tabCpds{$idSpecie}  = $nameSpecie;
		}
	}
	elsif ($line =~ "<listOfReactions>") {
		while(($line = <F>) && (!($line =~ "</listOfReactions>"))) {
			if ($line =~ "<reaction") {
				my ($idReac) = ($line =~ /id=\"([^\"]*)\"/);
				my ($nameReac) = ($line =~ /name=\"([^\"]*)\"/);

					
					my @genes = ("NA");
					my @proteins = ("NA");
					my $pathway = "NA";
					my $ecNumber = "NA";
					my $idCpd = "NA";
					my $nameCpd = "NA";
	
					while(($line = <F>) && (!($line =~ "</reaction>"))) {
						
						if ($line =~ "<notes>") {
	
							while(($line = <F>) && (!($line =~ "</notes>"))) {
								$line =~ s/or|and|[\(\)]//g;
								$line =~ s/<[^>]*>//g;
	
								if($line =~ "SUBSYSTEM") {
									$line =~ s/SUBSYSTEM:\s//;
									for ($line) { # Retire les espaces en debut et en fin de ligne
										s/^\s+//;
										s/\s+$//;
									}
	
									if($line ne "") {
										$pathway = $line;
									}
								}
								if($line =~ "PROTEIN_CLASS") {
									$line =~ s/PROTEIN_CLASS:\s//;
									for ($line) { # Retire les espaces en debut et en fin de ligne
										s/^\s+//;
										s/\s+$//;
									}
									if($line ne "") {
										$ecNumber = $line;
									}
								}
							}
						}
		
						if ($line =~ "<listOfReactants>") {
							while(($line = <F>) && (!($line =~ "</listOfReactants>"))) {
								if($line =~ "speciesReference") {
									($idCpd) = ($line =~ /species=\"([^\"]*)\"/);
									$nameCpd = $tabCpds{$idCpd};

									print sbmlDecode($idReac)."\t".sbmlDecode($pathway)."\t".sbmlDecode($pathway)."\t".sbmlDecode($idCpd)."\t"."substrate"."\t".sbmlDecode($nameCpd)."\t".$ecNumber."\t"."NA"."\t"."NA"."\t"."NA"."\t"."NA"."\t"."NA"."\n";
								}
							}
						}
	
						if ($line =~ "<listOfProducts>") {
							while(($line = <F>) && (!($line =~ "</listOfProducts>"))) {
								if($line =~ "speciesReference") {
									($idCpd) = ($line =~ /species=\"([^\"]*)\"/);
									$nameCpd = $tabCpds{$idCpd};
									print sbmlDecode($idReac)."\t".sbmlDecode($pathway)."\t".sbmlDecode($pathway)."\t".sbmlDecode($idCpd)."\t"."product"."\t".sbmlDecode($nameCpd)."\t".$ecNumber."\t"."NA"."\t"."NA"."\t"."NA"."\t"."NA"."\t"."NA"."\n";
								}
							}
						}
					}
			}
		}
	}
	else {
		$line = <F>;
	}	
}

# while (my ($key, $valeur) = each(%tabCpds)) {
# 	print $key."\t".$valeur."\n";
# }

sub toChr {
	my $str = $_[0];
	$str = substr($str, 2, length($str) - 4); 
	
	return (chr($str));
}


sub htmlDecode {
  
  my $str = $_[0];

  $str =~ s/("less_than")/"&lt"/gei;
  $str =~ s/("greater_than")/"&gt"/gei;
  $str =~ s/("&amp")/"&"/gei;
  $str =~ s/("&quot")/"\""/gei;
  $str =~ s/("&apos")/"\'"/gei;
  
  return($str);
}

sub sbmlDecode {

	my $str = htmlDecode($_[0]);
	
        $str =~ s/([^_])_(\d)/$1.$2/gei; 
	
        $str =~ s/^_(\d)/$1/gei; 

	$str =~ s/(__[0-9]+__)/toChr($1)/gei; 
	
	return ($str);
}

close F;

