#ifndef _ORGANISM_H
#define _ORGANISM_H

#include <list>
class Enzyme;

using namespace std;

/**
 * Contains all information on an organism. An organism is identified by an three letter code. For each organism, you have all the enzymes (ec numbers) whose catalytic activity has been demonstrated for the considered organism.
 */
class Organism
{
private:
  char *id;
  list <Enzyme *> *enzymes;
 public:
  Organism(char *name);
  ~Organism();

  char *get_id();
  void add_enzyme(Enzyme *);
};

#endif
