/* Pathway.h
 *
 * Copyright (C) 2007 Laboratoire de Biométrie et Biologie Évolutive
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _PATHWAY_H
#define _PATHWAY_H

#include "my_library.h"

class Reaction;

class Pathway
{
 private:
  char *id;
  char *name;
  list<Reaction *> *reactions;
  /* char id[MAX]; */
/*   char name[MAX]; */
 public:
  Pathway();
  Pathway(char *,char *);
  ~Pathway();
  char *get_id();
  list <Reaction *> *get_reactions();  //we need this function because reactions cannot be treated right from the pathway class
  int add_reaction(Reaction *);
  void print_more();
  void print();
  void print(ostream &);
  //void print_pathway_reactions(ostream &);  //doesn't work properly cos the pathway cannot handle reactions (problems in the recursive inclusions)
};

#endif


