/* Metabolic_Motif.cpp
 *
 * Copyright (C) 2007 Laboratoire de Biomtrie et Biologie volutive
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../include/Metabolic_Motif.h"
#include <iostream>
#include <fstream>
#include <cstdlib>

Metabolic_Motif::Metabolic_Motif(Data *my_data)
{
  //cout <<"je cre mon motif mtabolique"<<endl;
  enzymes = new list<Enzyme *>;
  local_gap = 0;
  global_gap = 0;
  quorum = 1.0;
  sigma_E = 3;  //3 is chosen randomly it should be passed from main
  input_compound = my_data->compound_adress_book("Pectin");
  output_compound = my_data->compound_adress_book("Hyaluronate");

  /*test sur le jeu de donnes bidon*/
  //Enzyme *enzyme1 = my_data->enzyme_adress_book("2.1.1.13");  //Rq : there is a problem if the enzyme is not in the network
  //Enzyme *enzyme2 = my_data->enzyme_adress_book("4.4.1.8");
  //Enzyme *enzyme3 = my_data->enzyme_adress_book("1.1.1.104");

  /*tests pour les matches multiples*/
  //Enzyme *enzyme1 = my_data->enzyme_adress_book("1.1.1.103");
  //Enzyme *enzyme2 = my_data->enzyme_adress_book("1.1.1.104");

  //Enzyme *enzyme1 = my_data->enzyme_adress_book("4.2.99.2");  //Rq : there is a problem if the enzyme is not in the network
  //Enzyme *enzyme2 = my_data->enzyme_adress_book("1.1.1.103");
  //Enzyme *enzyme3 = my_data->enzyme_adress_book("4.4.1.8"); 

  /*test sur les donnes kegg : exemple d'Anne*/ 
  Enzyme *enzyme1 = my_data->enzyme_adress_book("2.3.3.1");  //Rq : there is a problem if the enzyme is not in the network
  cout<<"hop"<<endl;
  Enzyme *enzyme2 = my_data->enzyme_adress_book("4.2.1.3");
  cout<<"hop"<<endl;
  Enzyme *enzyme3 = my_data->enzyme_adress_book("4.2.1.36");
  cout<<"hop"<<endl;
  Enzyme *enzyme4 = my_data->enzyme_adress_book("1.1.1.42");  
  cout<<"hop"<<endl;
  //Enzyme *enzyme5 = my_data->enzyme_adress_book("1.1.1.42");
  cout<<"hop"<<endl;
  //Enzyme *enzyme6 = my_data->enzyme_adress_book("2.6.1.39");
  cout<<"hop"<<endl;
 


  enzymes->push_back(enzyme1);
  enzymes->push_back(enzyme2);
  enzymes->push_back(enzyme3);
  enzymes->push_back(enzyme4);
  //enzymes.push_back(enzyme5);
  //enzymes.push_back(enzyme6);

  cout <<"j'ai fini , mon motif contient "<<enzymes->size()<<" enzymes"<<endl;
}


bool extract_word7(char *str, char *word, char end_of_word, int *i)
{
  if (str[*i]=='\0')
    return 0;

  //extracts a word from a line, whithdrawing the blanks
  int j=0;
  while (str[*i] != end_of_word)
    {
      if (str[*i]!=' ') 
	{
	  word[j]=str[*i];
	  (*i)++;
	  j++;
	}
      else  (*i)++;
    }
  word[j]='\0';
  (*i)++;
  return 1;
}

/*Do I really need the whole of Data ?*/
Metabolic_Motif::Metabolic_Motif(Data *my_data, int lg, int gg, int q, int se, char *enzymes_str, char *input_str, char *output_str, char *results_file)
{
  enzymes = new list<Enzyme *>;
  local_gap = lg;
  global_gap = gg;
  quorum = (float)q/100;
  sigma_E = se;  
  Enzyme *enzyme=NULL;

  char *ec_number = (char *)malloc(MAX*sizeof(char));
  int i=0;

  /*parsing of the enzyme string (given as a parameter by the user) in order to create objects corresponding to the queried EC numbers which we strore in the list "enzymes"*/
  while (extract_word7(enzymes_str, ec_number,' ',&i))
    {
      enzyme = new Enzyme(ec_number);
      enzymes->push_back(enzyme);
    }
  free(ec_number);

  /*input compound*/
  if (input_str[0] != '\0')
    {
      input_compound = my_data->compound_adress_book(input_str);
      if (input_compound == NULL)
	{
	  cerr <<"your input compound "<<input_str<<" is unknown, please choose another one (EX : C01011)"<<endl;
	  exit(0);
	}
    }

  /*output compound*/
  if (output_str[0] != '\0')
  {
    output_compound = my_data->compound_adress_book(output_str);
    if (output_compound == NULL)
      {
	cerr <<"your output compound "<<output_str<<" is unknown, please choose another one (EX : C00001)"<<endl;
	exit(0);
      }
  }

  /*fill colours*/
  /*The idea is to describe EC numbers as integers for future search of motifs (one has to take care of identical EC numbers and EC numbers which are included one into the other)*/
  /*two enzymes have the same colour if they are strictly identical*/
  /*The case where EC numbers are included one into the other is not handled here but in the coloring of reactions. Indeed, if the motif contains 1.1.1 and 1.1 then this will correspond here to two different integers (colours) and in the dataset, reactions catalysed by EC number 1.1.1.* will be assigned both colours*/
    
  /*memory allocation*/
  colours = new int[enzymes->size()];
  //int j=0;
  /*initialization*/
  // for (int i=0;i<(int)enzymes->size();i++)
//     colours[i]=i;

  /*initialization*/
  list<Enzyme *>::iterator enz_iter=enzymes->begin();
  for (int i=0;i<(int)enzymes->size();i++)
    {
      //print_tab((*enz_iter)->get_EC_number(),4);
      //print_mat(my_data->EC_numbers,my_data->nb_EC,4);
      colours[i]=get_index((*enz_iter)->get_EC_number(),my_data->colours_EC,my_data->nb_colours);
      if (colours[i]==-1)
	{
	  /*print to standard output*/
	  cout<<"this EC number: ";
	  (*enz_iter)->print();
	  cout<<" is not in the dataset"<<endl;
	  cout<<"try another one"<<endl;
	  
	  /*print to file so that Motus Web can handle the error: this
	    could be handled as an exception*/
	  std::ofstream output;
	  output.open(results_file);
	  //output<<"this EC number: ";
	  output<<"$"<<(*enz_iter)->get_ec();
	  output<<" is not in the dataset"<<endl;
	  output<<"$Please try another EC number"<<endl;
	  output.close();

	  exit(0);
	}
      enz_iter++;
    }

  /*take into account similar EC numbers to give them the same colour -- is this still useful ?*/
  i=0;
  int j=0;
  for (list<Enzyme *>::iterator it=enzymes->begin();it!=enzymes->end();it++)
    {
      j=i;
      for (list<Enzyme *>::iterator it2=it;it2!=enzymes->end();it2++)
	{
	  if (it!=it2)
	    if((*it)->is_similar_to(*it2) && (*it2)->is_similar_to(*it))
	      colours[j]=colours[i];
	  j++;
	}
      i++;
    }
  // cout <<"voici mon motif"<<endl;
//   for (list<Enzyme *>::iterator iter=enzymes->begin(); iter!=enzymes->end(); iter++)
//     (*iter)->print();

//   cout<<"voici mes couleurs"<<endl;
//   for (int i=0;i<(int)enzymes->size();i++)
//     cout<<colours[i]<<" ";
//   cout<<endl;
//  exit(0);
}

/*since new enzymes have been created for the motif, we delete them when we delete the motif*/
Metabolic_Motif::~Metabolic_Motif()
{
  //enzymes->clear();
  /*deletion of the enzymes inside the list*/
  for (list<Enzyme *>::iterator it=enzymes->begin();it!=enzymes->end();it++)
    delete(*it);
  /*deletion of the list*/
  delete(enzymes);
  delete[](colours);
}

//returns true if the enzyme to compare matches at least one enzyme from the motif
bool Metabolic_Motif::contains_similar_enzyme(Enzyme *enz_to_compare)
{
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  while (enz_iter != enzymes->end())
    {
      //if  (enz_to_compare->is_similar_to(*enz_iter,sigma_E))
      if  (enz_to_compare->is_similar_to(*enz_iter))
	{	
	  return true;
	}
      enz_iter++;
    }
  return false;
}

//returns all the enzymes (ranks) that match to the enzyme to compare
//complexity : O(motif.size())
bool *Metabolic_Motif::enzyme_ranks(Enzyme *enz_to_compare)
{
  int rank=0;
  bool *ranks = (bool*)malloc(enzymes->size()*sizeof(bool));  //should be passed in parameter ?
  /*initialize*/
  for (int j=0;j<(int)enzymes->size();j++)
    ranks[j]=0;
  /*fill tab*/
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  while (enz_iter != enzymes->end())
    {
      //if  (enz_to_compare->is_similar_to(*enz_iter,sigma_E))
      if  (enz_to_compare->is_similar_to(*enz_iter))
	ranks[rank]=1;
      enz_iter++;
      rank++;
    }
  return ranks;
}

//returns all the enzymes (ranks) that match to the enzyme to compare
//same as before except that the result is passed in parameter
//complexity : O(motif.size())
void Metabolic_Motif::enzyme_ranks(Enzyme *enz_to_compare, list<int> *ranks)
{
  /*declaration + initialization*/
  int rank=0;
 
  /*filling of tab*/
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  while (enz_iter != enzymes->end())
    {
      // if  (enz_to_compare->is_similar_to(*enz_iter,sigma_E))
      if  (enz_to_compare->is_similar_to(*enz_iter))
	ranks->push_back(rank);
      enz_iter++;
      rank++;
    }
}

/*in case you don't care about multiple matches, just look at the first match*/
/*this is used for setting colors for drawing the solutions*/
int Metabolic_Motif::enzyme_first_rank(Enzyme *enz_to_compare)
{
  int rank=0;
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  while (enz_iter != enzymes->end())
    {
      if  (enz_to_compare->is_similar_to(*enz_iter))
	return rank;
      enz_iter++;
      rank++;
    }
  return -1;
}

/*returns the number of groups of order you can expect given the set of colors you have*/
/*Ex : red green blue gives 3 groups : r g b // r b g  // b r g  (don't forget that if you can read it backwards, you get fewer groups)*/
int Metabolic_Motif::nb_groups_expected()
{
  /*I don't know the general rule for the moment, so I give all the cases*/
  //cout<<"nb_groups_expected"<<endl;
  int size=enzymes->size();
  int *color_repeats = new int[size];
  for (int i=0;i<size;i++)
    {
      color_repeats[i]=0;
      for (int j=0;j<size;j++)
	if (colours[i]==colours[j])
	  color_repeats[i]++;
    }

  int answer=0;
  /*for size 4*/
  if (size == 4)
    {
      int sum = 0;
      for (int i=0;i<size;i++)
	sum+=color_repeats[i];
      //cout<<"sum = "<<sum<<endl;
      switch(sum)
	{
	case 16 : answer = 1;
	  break;
	case 10 : answer=2;
	  break;
	case 8 : answer=4;
	  break;
	case 6 : answer=6;
	  break; 
	case 4 : answer=12;
	  break; 
	}
    }              
  delete(color_repeats);
  return answer;
}

/*returns the colour of the first enzyme from the motif that matches the query enzyme*/
int Metabolic_Motif::get_colour(Enzyme *enz_to_compare)
{
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  for (int i=0;i<(int)enzymes->size();i++)
    {
      if  (enz_to_compare->is_similar_to(*enz_iter))
	return colours[i];
      enz_iter++;
    }
  return -1;
}

//returns all the enzymes (colours) that match to the enzyme to compare
void Metabolic_Motif::get_colours(Enzyme *enz_to_compare, list<int> *reaction_colours)
{
  list<Enzyme *>::iterator enz_iter = enzymes->begin();
  for (int i=0;i<(int)enzymes->size();i++)
    {
      if  (enz_to_compare->is_similar_to(*enz_iter))
	reaction_colours->push_back(colours[i]);
      enz_iter++;
    }
}

int *Metabolic_Motif::get_colours()
{
  return colours;
}

//maybe all these parameters should not be in this class but in main.cpp
int Metabolic_Motif::get_local_gap()
{
  return local_gap;
}

int Metabolic_Motif::get_global_gap()
{
  return global_gap;
}

float Metabolic_Motif::get_quorum()
{
  return quorum;
}

Compound * Metabolic_Motif::get_input()
{
  return input_compound;
}

Compound * Metabolic_Motif::get_output()
{
  return output_compound;
}

int Metabolic_Motif::size()
{
  return enzymes->size();
}

void Metabolic_Motif::print_enzymes(std::ostream& output)
{
  for (list<Enzyme *>::iterator it=enzymes->begin(); it !=enzymes->end(); it++)
    {
      (*it)->print(output);
      output<<" ";
      //fprintf(output, " ");
    }
}

void  Metabolic_Motif::print_colours()
{
  for (int i=0;i<(int)enzymes->size();i++)
    cout<<colours[i]<<" ";
  cout<<endl;
}
