/* Pathway.cpp
 *
 * Copyright (C) 2007 Laboratoire de Biométrie et Biologie Évolutive
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../include/Pathway.h"
#include "../include/my_library.h"
#include <iostream>
#include <map>
#include <cstring>
#include <cstdlib>

using namespace std;

//extern map<void*,bool> pathwaysPtrs;

Pathway::Pathway()
{
}

Pathway::Pathway(char *path_id, char *path_name)
{
  //pathwaysPtrs[this]=false;
  //id = (char*)malloc((strlen(path_id)+1)*sizeof(char));
  //id = strcpy(id,path_id);
  id = (char*)malloc((strlen(path_id)+1)*sizeof(char));
  //string_copy(id, path_id);
  id = strcpy(id,path_id);
  //name = (char*)malloc((strlen(path_name))+1*sizeof(char));
  name = (char*)malloc((strlen(path_name)+1)*sizeof(char));
  name = strcpy(name,path_name);
  //string_copy(name, path_name);
  reactions = new list <Reaction *>;
}


Pathway::~Pathway()
{
  free(id);
  free(name);
  delete(reactions);
}

char *Pathway::get_id()
{
  return id;
}

list <Reaction *> *Pathway::get_reactions()
{
  return reactions;
}

/**Adds a reaction to the list of reactions of the pathway. Also checks that the reaction is not already in the list
 *
*/
int Pathway::add_reaction(Reaction *reaction_to_add)  //do we need to traverse this list to verify the pathway is not already in the list ?
{
  list<Reaction *>::iterator rea_iter;
  rea_iter = reactions->begin();
  while (rea_iter != reactions->end())
    {
      if (reaction_to_add == *rea_iter)
	return 0;
      rea_iter++;
    }
  reactions->push_back(reaction_to_add);
  return 1;
}


void Pathway::print_more()
{
  cout <<"Pathway name : "<<name<<"   id : "<<id;
}

void Pathway::print()
{
  if (strcmp(id, "NA")==0)
    cout<<"unclassified";
  else  
    cout <<id;
}

void Pathway::print(ostream& output)
{
  if (strcmp(name, "NA")==0)
    output<<"unclassified";
  else  
    output <<name;
  //cout <<"Reaction name :"<<name<<"id "<<id<<endl;
}

// /*prints to file the pathway and the reactions in it*/
// void Pathway::print_pathway_reactions(ostream& output)
// {
//   for (list<Reaction *>::iterator iter=reactions->begin(); iter!=reactions->end(); iter++)
//     {
//       output<<name;
//       output<<"\t";
//       //(*iter)->print(output);
//       output<<endl;
//     }
// }
